## wordgrinder 0.5.1

=== Makefile ===
--- 
+++ 
@@ -10,9 +10,15 @@
 WINDRES = windres.exe
 MAKENSIS = makensis
 
-VERSION := 0.4.1
-FILEFORMAT := 3
-DATE := 14 April 2013
+ifneq ($(findstring Windows,$(OS)),)
+OS = windows
+else
+OS = unix
+endif
+
+VERSION := 0.5.1
+FILEFORMAT := 4
+DATE := $(shell date +'%-d %B %Y')
 
 override CFLAGS += \
 	-DVERSION='"$(VERSION)"' \
@@ -23,7 +29,7 @@
 	-Wall \
 	-ffunction-sections \
 	-fdata-sections \
-	--std=c99
+	--std=gnu99
 
 override LDFLAGS += \
 
@@ -82,6 +88,8 @@
 	src/lua/addons/autosave.lua \
 	src/lua/addons/docsetman.lua \
 	src/lua/addons/scrapbook.lua \
+	src/lua/addons/pagecount.lua \
+	src/lua/addons/widescreen.lua \
 	src/lua/menu.lua \
 	src/lua/cli.lua \
 	src/lua/main.lua
@@ -103,6 +111,12 @@
 	@echo CC $$@
 	@mkdir -p $$(dir $$@)
 	$(hide)$(cc) $(CFLAGS) $(cflags) $(INCLUDES) -c -o $$@ $1
+
+$(objdir)/$(1:.c=.d): $1 Makefile
+	@echo DEPEND $$@
+	@mkdir -p $$(dir $$@)
+	$(hide)$(cc) $(CFLAGS) $(cflags) $(INCLUDES) \
+		-MP -MM -MT $(objdir)/$(1:.c=.o) -MF $$@ $1
 
 DEPENDS += $(objdir)/$(1:.c=.d)
 objs += $(objdir)/$(1:.c=.o)
@@ -194,9 +208,14 @@
 $(call cfile, src/c/arch/win32/gdi/realmain.c)
 $(call rcfile, src/c/arch/win32/wordgrinder.rc)
 
+src/c/arch/win32/wordgrinder.rc: \
+	src/c/arch/win32/manifest.xml
+
 endef
 
 # --- Unix ------------------------------------------------------------------
+
+ifeq ($(OS),unix)
 
 cc := gcc
 INCLUDES := -I/usr/include/lua5.2
@@ -205,6 +224,7 @@
 	-D_XOPEN_SOURCE_EXTENDED \
 	-D_XOPEN_SOURCE \
 	-D_GNU_SOURCE \
+	-DARCH=\"unix\" \
 	-I/usr/include/ncursesw
 	
 ldflags := \
@@ -245,8 +265,12 @@
 bin/wordgrinder.1: wordgrinder.man
 	@echo MANPAGE
 	$(hide)sed -e 's/@@@DATE@@@/$(DATE)/g; s/@@@VERSION@@@/$(VERSION)/g' $< > $@
+
+endif
 	
 # --- Windows ---------------------------------------------------------------
+
+ifeq ($(OS),windows)
 
 cc := $(WINCC)
 
@@ -255,11 +279,13 @@
 	-DBUILTIN_LFS \
 	-DWIN32 \
 	-DWINVER=0x0501 \
+	-DARCH=\"windows\" \
 	-Dmain=appMain \
 	-mwindows
-	
+
 ldflags := \
 	-static \
+	-lcomctl32 \
 	-llua \
 	-lz
 
@@ -286,7 +312,9 @@
 $(eval $(build-wordgrinder-windows))
 $(eval $(build-wordgrinder))
 
-src/c/arch/win32/wordgrinder.rc: src/c/arch/win32/icon.ico
+src/c/arch/win32/wordgrinder.rc: \
+	src/c/arch/win32/icon.ico \
+	src/c/arch/win32/manifest.xml
 
 
 $(WININSTALLER): extras/windows-installer.nsi bin/wordgrinder.exe
@@ -298,6 +326,9 @@
 	@echo CLEAN $(WININSTALLER)
 	@rm -f $(WININSTALLER)
 	
+endif
+
 # --- Final setup -----------------------------------------------------------
 
 -include $(DEPENDS)
+
