=== debian/changelog ===
wordgrinder (0.6-3build1) xenial; urgency=medium

  * No-change rebuild for ncurses6 transition.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 07 Feb 2016 09:47:29 +0000

wordgrinder (0.6-3) unstable; urgency=medium

  * Fix missing dependency (Closes: #801909)

 -- David Given <dg@cowlark.com>  Sat, 17 Oct 2015 12:12:04 +0200

wordgrinder (0.6-2) unstable; urgency=medium

  * Fix debian/rules bug that was causing FTBFS on the build servers
    (Closes: #801697)
  * Update urgency to 'medium' (the new standard)

 -- David Given <dg@cowlark.com>  Tue, 13 Oct 2015 21:29:22 +0200

wordgrinder (0.6-1) unstable; urgency=low

  * New upstream release

 -- David Given <dg@cowlark.com>  Thu, 24 Sep 2015 23:47:32 +0200

wordgrinder (0.5.1-1) unstable; urgency=low

  * New upstream release

 -- David Given <dg@cowlark.com>  Fri, 13 Dec 2013 01:23:54 +0000

wordgrinder (0.4.1-1) unstable; urgency=low

  * New upstream release

 -- David Given <dg@cowlark.com>  Sun, 14 Apr 2013 21:12:31 +0000

wordgrinder (0.3.3-1) unstable; urgency=low

  * New upstream release

 -- David Given <dg@cowlark.com>  Mon, 14 Dec 2009 21:42:12 +0000

wordgrinder (0.3.2-1) unstable; urgency=low

  * New upstream release

 -- David Given <dg@cowlark.com>  Thu, 19 Feb 2009 23:54:29 +0000

wordgrinder (0.3.1-1) unstable; urgency=low

  * New upstream release

 -- David Given <dg@cowlark.com>  Mon, 15 Sep 2008 23:14:39 +0100

wordgrinder (0.2-2) unstable; urgency=low

  * Fixed incorrect Depends: line (Closes: #464002)
  * Backported fix from upstream about not being able to rebind keys 
    that had a default keybinding (Closes: #464007)

 -- David Given <dg@cowlark.com>  Mon, 04 Feb 2008 20:45:50 +0000

wordgrinder (0.2-1) unstable; urgency=low

  * Initial release (Closes: #461515)

 -- David Given <dg@cowlark.com>  Sat, 19 Jan 2008 10:13:06 +0000
