=== debian/control ===
Source: wordgrinder
Section: editors
Priority: optional
Maintainer: David Given <dg@cowlark.com>
Build-Depends: debhelper (>= 9.0.0), libncursesw5-dev, liblua5.2-dev, lua-filesystem-dev, lua5.2, dpkg-dev (>= 1.16.1~), zlib1g-dev, libxft-dev
Standards-Version: 3.9.6
Homepage: http://cowlark.com/wordgrinder

Package: wordgrinder
Depends: wordgrinder-ncurses, ${misc:Depends}
Architecture: all
Priority: extra
Section: oldlibs
Description: simple word processor for writing first drafts
 This is a transitional dummy package. It can safely be removed.

Package: wordgrinder-ncurses
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, wordgrinder-doc, lua-filesystem
Replaces: wordgrinder (<< 0.6-1)
Breaks: wordgrinder (<< 0.6-1)
Description: simple word processor for writing first drafts (terminal version)
 WordGrinder is a simple, Unicode-aware word processor. It supports basic
 paragraph styles, character styles, just enough screen markup to be useful,
 and is driven via an easy to use menu interface.
 .
 This version runs in a terminal.

Package: wordgrinder-x11
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, wordgrinder-doc, lua-filesystem
Description: simple word processor for writing first drafts (X11 version)
 WordGrinder is a simple, Unicode-aware word processor. It supports basic
 paragraph styles, character styles, just enough screen markup to be useful,
 and is driven via an easy to use menu interface.
 .
 This version runs on X.

Package: wordgrinder-doc
Architecture: all
Depends: ${misc:Depends}
Section: doc
Description: simple word processor for writing first drafts (documentation)
 WordGrinder is a simple, Unicode-aware word processor. It supports basic
 paragraph styles, character styles, just enough screen markup to be useful,
 and is driven via an easy to use menu interface.
 .
 This package contains the documentation.
