=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

# Use hardening build flags.
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

.PHONY: override_dh_auto_build
override_dh_auto_build:
	dh_testdir
	make bin/wordgrinder bin/xwordgrinder \
		CFLAGS="$(CPPFLAGS) $(CFLAGS)" \
		LDFLAGS="$(LDFLAGS)"
	
.PHONY: override_dh_auto_test
override_dh_auto_test:
	dh_testdir
	make tests \
		CFLAGS="$(CPPFLAGS) $(CFLAGS)" \
		LDFLAGS="$(LDFLAGS)"

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	rm -rf .obj bin

.PHONY: override_dh_auto_install
override_dh_auto_install:

.PHONY: override_dh_install
override_dh_install:
	make install PREFIX=debian/tmp/usr
	dh_install

%:
	dh $@
