=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/<project>-$1\.tar\.gz/ \
  http://github.com/davidgiven/wordgrinder/releases .*/(\d\S*)\.tar\.gz
