=== debian/changelog ===
wordgrinder (0.7.1-1) unstable; urgency=medium

  * New upstream release

 -- David Given <dg@cowlark.com>  Thu, 2 Nov 2017 18:53:00 +0000

wordgrinder (0.6-4) unstable; urgency=medium

  * Fix reproducible build (Closes: #831742)
  * Bump standards version.

 -- David Given <dg@cowlark.com>  Mon, 30 Jan 2017 21:09:34 +0000
