=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: editors
 Priority: optional
 Maintainer: David Given <dg@cowlark.com>
-Build-Depends: debhelper (>= 9.0.0), libncursesw5-dev, liblua5.2-dev, lua-filesystem-dev, lua5.2, dpkg-dev (>= 1.16.1~), zlib1g-dev, libxft-dev
-Standards-Version: 3.9.6
+Build-Depends: debhelper (>= 9.0.0), ninja-build, libncursesw5-dev, liblua5.3-dev, lua-filesystem-dev, dpkg-dev (>= 1.16.1~), zlib1g-dev, libxft-dev, libminizip-dev, uthash-dev, lua5.1
+Standards-Version: 3.9.8
 Homepage: http://cowlark.com/wordgrinder
 
 Package: wordgrinder
