## wordgrinder 0.7.2

=== Makefile ===
--- 
+++ 
@@ -31,7 +31,7 @@
 endif
 
 # Application version and file format.
-VERSION := 0.7.1
+VERSION := 0.7.2
 FILEFORMAT := 7
 DATE ?= $(shell date +'%-d %B %Y')
 
@@ -49,13 +49,20 @@
 # Hack to try and detect the presence of the Xft library (it's not in
 # pkg-config).
 ifneq ($(wildcard /usr/include/X11/Xft/Xft.h),)
-	XFT_PACKAGE ?= --libs={-lX11 -lXft}
+	XFT_PACKAGE ?= \
+		--cflags={-I/usr/include/X11} --libs={-lX11 -lXft}
+else ifneq ($(wildcard /usr/X11R6/include/X11/Xft/Xft.h),)
+	XFT_PACKAGE ?= \
+		--cflags={-I/usr/X11R6/include -I/usr/X11R6/include/X11} \
+		--libs={-L/usr/X11R6/lib -lX11 -lXft}
 else
 	XFT_PACKAGE ?= none
 endif
 
 # Hack to try and detect OSX's non-pkg-config compliant ncurses.
 ifneq ($(filter Darwin%,$(shell uname)),)
+	CURSES_PACKAGE ?= --cflags={-I/usr/include} --libs={-L/usr/lib -lncurses}
+else ifneq ($(filter OpenBSD,$(shell uname)),)
 	CURSES_PACKAGE ?= --cflags={-I/usr/include} --libs={-L/usr/lib -lncurses}
 else
 	CURSES_PACKAGE ?= ncursesw
@@ -76,6 +83,10 @@
 LUABITOP_PACKAGE ?= builtin
 MINIZIP_PACKAGE ?= builtin
 UTHASH_PACKAGE ?= builtin
+
+# Do you want your binaries stripped on installation?
+
+WANT_STRIPPED_BINARIES ?= yes
 
 # ===========================================================================
 #                       END OF CONFIGURATION OPTIONS
@@ -100,6 +111,11 @@
 .PHONY: install
 install: $(OBJDIR)/build.ninja
 	$(NINJABUILD) install
+
+# Builds and installs the Unix release versions only, without testing.
+.PHONY: install-notests
+install-notests: $(OBJDIR)/build.ninja
+	$(NINJABUILD) install-notests
 
 # Builds and tests everything that's buildable on your machine.
 .PHONY: dev
@@ -134,13 +150,14 @@
 		OBJDIR="$(OBJDIR)" \
 		UTHASH_PACKAGE="$(UTHASH_PACKAGE)" \
 		VERSION="$(VERSION)" \
+		WANT_STRIPPED_BINARIES="$(WANT_STRIPPED_BINARIES)" \
 		WINCC="$(WINCC)" \
 		WINDRES="$(WINDRES)" \
 		XFT_PACKAGE="$(XFT_PACKAGE)" \
 
 clean:
 	@echo CLEAN
-	@rm -rf $(OBJDIR)
+	@rm -rf $(OBJDIR) bin
 
 ifeq ($(LUA_INTERPRETER),$(OBJDIR)/lua)
 $(LUA_INTERPRETER): src/c/emu/lua-5.1.5/*.[ch]
