=== debian/changelog ===
wordgrinder (0.7.2-1) unstable; urgency=medium

  * New upstream release

 -- David Given <dg@cowlark.com>  Thu, 29 Nov 2018 21:18:05 +0100
