=== debian/control ===
--- 
+++ 
@@ -9,7 +9,6 @@
 Package: wordgrinder
 Depends: wordgrinder-ncurses, ${misc:Depends}
 Architecture: all
-Priority: extra
 Section: oldlibs
 Description: simple word processor for writing first drafts
  This is a transitional dummy package. It can safely be removed.
