=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

# Exported to the package makefile.
PACKAGE_VARS = \
	PREFIX=/usr \
	DESTDIR=debian/tmp \
	OBJDIR=.obj \
	LUA_PACKAGE=lua-5.3 \
	LUABITOP_PACKAGE="--cflags={} --libs={}" \
	LUAFILESYSTEM_PACKAGE=lua5.3-filesystem \
	MINIZIP_PACKAGE=minizip \
	UTHASH_PACKAGE="--cflags={} --libs={}" \
	LUA_INTERPRETER=/usr/bin/lua5.1 \
	CFLAGS="$(CPPFLAGS) $(CFLAGS)" \
	LDFLAGS="$(LDFLAGS)" \

# Use hardening build flags.
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

.PHONY: override_dh_auto_build
override_dh_auto_build:
	dh_testdir
	make all $(PACKAGE_VARS)
	
.PHONY: override_dh_auto_test
override_dh_auto_test:
	dh_testdir
	make tests $(PACKAGE_VARS)

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	make clean $(PACKAGE_VARS)

.PHONY: override_dh_auto_install
override_dh_auto_install:

.PHONY: override_dh_install
override_dh_install:
	make install $(PACKAGE_VARS)
	dh_install

%:
	dh $@
