## wordgrinder 0.8

=== Makefile ===
--- 
+++ 
@@ -6,15 +6,27 @@
 
 PREFIX ?= $(HOME)
 BINDIR ?= $(PREFIX)/bin
-DOCDIR ?= $(PREFIX)/share/doc
-MANDIR ?= $(PREFIX)/share/man
+SHAREDIR ?= $(PREFIX)/share
+DOCDIR ?= $(SHAREDIR)/doc
+MANDIR ?= $(SHAREDIR)/man
 DESTDIR ?=
 
 # Where do the temporary files go?
-OBJDIR = /tmp/wg-build
+OBJDIR = .obj
 
 # The compiler used for the native build (curses, X11)
 CC ?= cc
+
+# Which ninja do you want to use?
+ifeq ($(strip $(shell type ninja >/dev/null; echo $$?)),0)
+	NINJA ?= ninja
+else
+	ifeq ($(strip $(shell type ninja-build >/dev/null; echo $$?)),0)
+		NINJA ?= ninja-build
+    else
+        $(error No ninja found)
+    endif
+endif
 
 # Global CFLAGS and LDFLAGS.
 CFLAGS ?=
@@ -31,9 +43,14 @@
 endif
 
 # Application version and file format.
-VERSION := 0.7.2
-FILEFORMAT := 7
-DATE ?= $(shell date +'%-d %B %Y')
+VERSION := 0.8
+FILEFORMAT := 8
+
+ifdef SOURCE_DATE_EPOCH
+       DATE := $(shell LC_ALL date --utc --date="@$(SOURCE_DATE_EPOCH)" +'%-d %B %Y')
+else
+       DATE := $(shell date +'%-d %B %Y')
+endif
 
 # Which Lua do you want to use?
 #
@@ -79,7 +96,7 @@
 # these only makes sense with 'make all' --- don't use this with
 # 'make dev' (but you probably won't be doing this anyway).
 
-LUAFILESYSTEM_PACKAGE ?= builtin
+LPEG_PACKAGE ?= builtin
 LUABITOP_PACKAGE ?= builtin
 MINIZIP_PACKAGE ?= builtin
 UTHASH_PACKAGE ?= builtin
@@ -100,7 +117,7 @@
 LUA_INTERPRETER = $(OBJDIR)/lua
 
 NINJABUILD = \
-	$(hide) ninja -f $(OBJDIR)/build.ninja $(NINJAFLAGS)
+	$(hide) $(NINJA) -f $(OBJDIR)/build.ninja $(NINJAFLAGS)
 
 # Builds and tests the Unix release versions only.
 .PHONY: all
@@ -117,21 +134,31 @@
 install-notests: $(OBJDIR)/build.ninja
 	$(NINJABUILD) install-notests
 
-# Builds and tests everything that's buildable on your machine.
+# Builds and tests everything that's buildable on your machine. Don't use this
+# unless you know what you're doing (it's pretty brittle given non-standard
+# build flags).
 .PHONY: dev
 dev: $(OBJDIR)/build.ninja
 	$(NINJABUILD) dev
 
-# Builds Windows (but doesn't test it because that's hard).
+# Builds Windows, possibly via cross-compilation (but doesn't test it because
+# we can only do that on actual Windows).
 .PHONY: windows
 windows: $(OBJDIR)/build.ninja
-	$(NINJABUILD) bin/WordGrinder-$(VERSION)-setup.exe
+	$(NINJABUILD) bin/WordGrinder-$(VERSION)-setup.exe 
+
+# Run the Windows tests
+.PHONY: wintests
+wintests: $(OBJDIR)/build.ninja
+	$(NINJABUILD) wintests
+
+.DELETE_ON_ERROR:
 
 $(OBJDIR)/build.ninja:: $(LUA_INTERPRETER) build.lua Makefile
 	@mkdir -p $(dir $@)
 	$(hide) $(LUA_INTERPRETER) build.lua \
 		BINDIR="$(BINDIR)" \
-		BUILDFILE="$@" \
+		BUILDFILE="$@.tmp" \
 		CC="$(CC)" \
 		CFLAGS="$(CFLAGS)" \
 		CURSES_PACKAGE="$(CURSES_PACKAGE)" \
@@ -141,19 +168,21 @@
 		FILEFORMAT="$(FILEFORMAT)" \
 		LDFLAGS="$(LDFLAGS)" \
 		LUABITOP_PACKAGE="$(LUABITOP_PACKAGE)" \
-		LUAFILESYSTEM_PACKAGE="$(LUAFILESYSTEM_PACKAGE)" \
+		LPEG_PACKAGE="$(LPEG_PACKAGE)" \
 		LUA_INTERPRETER="$(LUA_INTERPRETER)" \
 		LUA_PACKAGE="$(LUA_PACKAGE)" \
 		MAKENSIS="$(MAKENSIS)" \
 		MANDIR="$(MANDIR)" \
 		MINIZIP_PACKAGE="$(MINIZIP_PACKAGE)" \
 		OBJDIR="$(OBJDIR)" \
+		SHAREDIR="$(SHAREDIR)" \
 		UTHASH_PACKAGE="$(UTHASH_PACKAGE)" \
 		VERSION="$(VERSION)" \
 		WANT_STRIPPED_BINARIES="$(WANT_STRIPPED_BINARIES)" \
 		WINCC="$(WINCC)" \
 		WINDRES="$(WINDRES)" \
-		XFT_PACKAGE="$(XFT_PACKAGE)" \
+		XFT_PACKAGE="$(XFT_PACKAGE)"
+	$(hide) mv $@.tmp $@
 
 clean:
 	@echo CLEAN
@@ -163,6 +192,52 @@
 $(LUA_INTERPRETER): src/c/emu/lua-5.1.5/*.[ch]
 	@echo Bootstrapping build
 	@mkdir -p $(dir $@)
-	@$(CC) -o $(LUA_INTERPRETER) -O src/c/emu/lua-5.1.5/*.c -lm -DLUA_USE_MKSTEMP
-endif
-
+	@$(CC) -o $(LUA_INTERPRETER) -O src/c/emu/lua-5.1.5/*.c src/c/emu/tmpnam.c -lm -DLUA_USE_EMU_TMPNAM
+endif
+
+.PHONY: distr
+distr: wordgrinder-$(VERSION).tar.xz
+
+.PHONY: debian-distr
+debian-distr: wordgrinder-$(VERSION)-minimal-dependencies-for-debian.tar.xz
+
+.PHONY: wordgrinder-$(VERSION).tar.xz
+wordgrinder-$(VERSION).tar.xz:
+	tar cvaf $@ \
+		--transform "s,^,wordgrinder-$(VERSION)/," \
+		extras \
+		licenses \
+		scripts \
+		src \
+		testdocs \
+		tests \
+		tools \
+		build.lua \
+		Makefile \
+		README \
+		README.wg \
+		README.Windows.txt \
+		wordgrinder.man \
+		xwordgrinder.man
+
+.PHONY: wordgrinder-$(VERSION)-minimal-dependencies-for-debian.tar.xz
+wordgrinder-$(VERSION)-minimal-dependencies-for-debian.tar.xz:
+	tar cvaf $@ \
+		--transform "s,^,wordgrinder-$(VERSION)/," \
+		--exclude "*.dictionary" \
+		--exclude "src/c/emu" \
+		extras \
+		licenses \
+		scripts \
+		src \
+		testdocs \
+		tests \
+		tools \
+		build.lua \
+		Makefile \
+		README \
+		README.wg \
+		README.Windows.txt \
+		wordgrinder.man \
+		xwordgrinder.man
+
