=== debian/changelog ===
wordgrinder (0.8-1) unstable; urgency=medium

  * New upstream release
  * Fix FTBFS with new version of ncurses (Closes: #971114)

 -- David Given <dg@cowlark.com>  Fri, 16 Oct 2020 21:22:20 +0200
