=== debian/control ===
--- 
+++ 
@@ -2,9 +2,10 @@
 Section: editors
 Priority: optional
 Maintainer: David Given <dg@cowlark.com>
-Build-Depends: debhelper (>= 9.0.0), ninja-build, libncursesw5-dev, liblua5.3-dev, lua-filesystem-dev, dpkg-dev (>= 1.16.1~), zlib1g-dev, libxft-dev, libminizip-dev, uthash-dev, lua5.1
-Standards-Version: 3.9.8
+Build-Depends: debhelper-compat (= 13), debhelper (>= 13.0.0), ninja-build, libncursesw5-dev, liblua5.3-dev, lua-lpeg-dev, dpkg-dev (>= 1.16.1~), zlib1g-dev, libxft-dev, libminizip-dev, uthash-dev, lua5.3, imagemagick
+Standards-Version: 4.5.0
 Homepage: http://cowlark.com/wordgrinder
+Rules-Requires-Root: no
 
 Package: wordgrinder
 Depends: wordgrinder-ncurses, ${misc:Depends}
