=== debian/rules ===
--- 
+++ 
@@ -14,12 +14,13 @@
 	OBJDIR=.obj \
 	LUA_PACKAGE=lua-5.3 \
 	LUABITOP_PACKAGE="--cflags={} --libs={}" \
-	LUAFILESYSTEM_PACKAGE=lua5.3-filesystem \
+	LPEG_PACKAGE=lua5.3-lpeg \
 	MINIZIP_PACKAGE=minizip \
 	UTHASH_PACKAGE="--cflags={} --libs={}" \
-	LUA_INTERPRETER=/usr/bin/lua5.1 \
+	LUA_INTERPRETER=/usr/bin/lua5.3 \
 	CFLAGS="$(CPPFLAGS) $(CFLAGS)" \
 	LDFLAGS="$(LDFLAGS)" \
+	WANT_STRIPPED_BINARIES=yes
 
 # Use hardening build flags.
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
@@ -49,5 +50,5 @@
 	dh_install
 
 %:
-	dh $@ 
+	dh $@
