=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/wordgrinder-$1\.tar\.gz/ \
  https://github.com/davidgiven/wordgrinder/releases .*/(\d\S*)\.tar\.gz
